Attribute VB_Name = "MakroCallback"
'******************************************************************************
'Module: MakroCallback.bas
'CallBack-Funktion fr die MakLoop Funktion der prtdraw4VB.dll
'AURICH Innenprojekt GmbH, K.Hiller
'12.08.2004 erstellt
'15.09.2004 berarbeitet (bereinigt)
'******************************************************************************
Option Explicit

'kopiert einen C-String im prtdraw.dll Speicherbereich auf welchen ein Zeiger verweist
'in eine VB-Variable mit definierter Lnge unterzuhilfenahme einer API-Funktion
Private Declare Function lpStr2Bstr Lib "kernel32" Alias "lstrcpynA" _
                        (ByVal lpString1 As String, _
                         ByVal lpString2 As Long, _
                         ByVal lngMaxLength As Long) As Long
                         
'ermittelt die Lnge eines C-Strings
Private Declare Function lpStrLen Lib "kernel32" Alias "lstrlenA" _
                         (ByVal lpString As Long) As Long
  
  
'Rckruffunktion fr MakLoop
'MakLoop wird ein Zeiger auf diese Funktion bergeben, MakLoop ruft dann diese Funktion
'bei vorhanden sein von Makros fr jedes Makro einmal auf und bergibt dabei dieser Funktion
'jedesmal die Daten des Makros. Diese Daten werden dabei in einem TreeView als Node gespeichert.
Public Function MakCallback( _
                ByVal lngX As Long, _
                ByVal lngY As Long, _
                ByVal lpName As Long, _
                ByVal lpInfo As Long, _
                ByVal lngInfoSize As Long, _
                ByRef lpData As Variant) As Long  '
  
  Static index As Long
  Dim zeile As Long
  Dim start As Long
  Dim ende As Long
  Dim name As String * 255
  Dim info As String * 1025
  Dim nodX As Node
  
  If lpData = 1 Then index = 0
  lpData = 0
  
  Call lpStr2Bstr(name, lpName, Len(name))
  Set nodX = frmMakro.treMac.Nodes.Add(, , ("C" & Str(index)), name)
  Set nodX = frmMakro.treMac.Nodes.Add(("C" & Str(index)), tvwChild, ("CB" & Str(index)), "Bezugspunkt")
  Set nodX = frmMakro.treMac.Nodes.Add(("CB" & Str(index)), tvwChild, ("CX" & Str(index)), ("X:" & Str(lngX)))
  Set nodX = frmMakro.treMac.Nodes.Add(("CB" & Str(index)), tvwChild, ("CY" & Str(index)), ("Y:" & Str(lngY)))
  Set nodX = frmMakro.treMac.Nodes.Add(("C" & Str(index)), tvwChild, ("CI" & Str(index)), "Info")
  'Infozeilen ermitteln und als einzelne Nodes einfgen
  start = 0
  ende = 0
  zeile = 0
  Do While start < lngInfoSize And start < 1024
    ende = lpStrLen(lpInfo + start) + 1
    If ende > Len(info) Then ende = Len(info)
    Call lpStr2Bstr(info, lpInfo + start, ende)
    Set nodX = frmMakro.treMac.Nodes.Add(("CI" & Str(index)), tvwChild, ("CIZ" & Str(index * 1025 + zeile)), RTrim(info))
    start = start + ende
    zeile = zeile + 1
  Loop
  index = index + 1
  
  MakCallback = 1
End Function

'Procedur zum testen der MakCallback Funktion
'erzeugt 3 Makro Datenstze indem sie 3x MakCallback aufruft
'und dabei Test-Parameter bergibt
Public Sub TestMakCallback()
  
  Dim i As Long
  Dim name As String
  Dim info As String
  Dim first As Long
  
  first = 1
  For i = 0 To 2
    name = "Baugruppe " & CStr(i)
    info = "Infozeile 1" & Chr(0) & "Infozeile 2" & Chr(0)
    
    If 0 = MakCallback(Int(Rnd * 1000), _
                       Int(Rnd * 1000), _
                       name, _
                       info, Len(info), first) Then Exit For
  Next
End Sub



