Attribute VB_Name = "PrtDraw"
'**********************************************************************
'* Module: prtdraw.bas
'* Aufruf der Funktionen aus der .\utils\prtdraw.dll von MegaCAD
'* MEGATECH Software GmbH, MegaCAD_3D_2004
'* AURICH Innenprojekt GmbH, K.Hiller,
'* 06.07.2004 Grundfunktionen implementiert
'**********************************************************************
Option Explicit

'Datenstrucktur zur Aufnahme von Rechteckkoordinaten
Public Type tRECT
  lngLeft    As Long
  lngTop     As Long
  lngRight   As Long
  lngBottom  As Long
End Type

'****************************C-CODE************************************/
'typedef int (_stdcall *tfpDrawPrt)(
'        char *fname,           // .PRT - file
'        HDC  hDC,              // device context
'        RECT *rDisp,           // display rectangle
'        RECT *rVirt,           // virtual rectangle (zooming)
'        RECT *rClip,           // clipping rectangle
'        uint flags );          // bits 0-3 background colour (VGA)
'                               // bit 4 => F_STOREMAK
'**********************************************************************/

'prtdraw.dll-Funktionsaufruf - DrawPrtFile - Funktionsnummer 1
'Achtung String mit Lnge und Abschlu NULL wird als ByVal deklariert,
'aber durch VB intern als C-String ByRef an die DLL bergeben
Declare Function DrawPrt Lib "prtdraw4VB.dll" Alias "#1" ( _
        ByVal sFName As String, _
        ByVal hDC As Long, _
        ByRef tRectDisp As Any, _
        ByRef tRectVirt As Any, _
        ByRef tRectClip As Any, _
        ByVal lFlags As Long) As Long
'return value :
'    >0  => version number of MegaCAD - file (ok)
'    =0  => no valid MegaCAD - file
'    -1  => could not open file 'fname'
'    -2  => everything clipped, nothing drawn
'    -3  => out of memory

'flag F_STOREMAK prepares for macro loop (see below)
'veranlast die Speicherung der Makrodaten fr MakLoop
Public Const F_STOREMAK As Byte = 2 ^ 4 ' (1<<4)
'stellt die Zeichnung monochrom dar (schwarz/wei bei weiem Hintergrund)
Public Const F_MONO     As Byte = 2 ^ 5 ' (1<<5)

'****************************C-CODE************************************/
'typedef void (_stdcall *tfpSetIni)(
'        char *szIni );     // name of a 'megacad.ini' filePublic Type t_fpSetIni
'**********************************************************************/

'prtdraw.dll-Funktionsaufruf - SetMegaIni - Funktionsnummer 2
'Achtung String mit Lnge und Abschlu NULL wird als ByVal deklariert,
'aber durch VB intern als C-String ByRef an die DLL bergeben
Declare Sub SetIni Lib "prtdraw4VB.dll" Alias "#2" ( _
        ByVal sIni As String)

'**********************************************************************/
'Die folgenden Funktionen funktionieren nur mit der gepatchten DLL
'andernfalls erfolgt ein Absturz, falls Makrodaten vorhanden sind!!!
'**********************************************************************/

'****************************C-CODE************************************/
'typedef long (_stdcall *tfpMakLoop)(
'        tfpMakCB func,          // Callback function
'        void     *cbPtr );      // pointer to user defined data
'**********************************************************************/

'prtdraw.dll-Funktionsaufruf - MakroLoop - Funktionsnummer 3
Declare Function MakLoop Lib "prtdraw4VB.dll" Alias "#3" ( _
        ByVal pfMacCB As Long, _
        ByRef varData As Any) As Long
'return value :
'   number of Macros

'****************************C-CODE************************************/
'typedef int (_cdecl *tfpMakCB)(
'        int   px,               // point of reference: x
'        int   py,               // point of reference: y
'        uchar *fname,           // filename of macro file
'        uchar *info,            // macro info (each line '\0'-terminated)
'        uint  isize,            // size (in bytes) of macro info
'        void  *cbPtr );         // pointer to user defined data
'**********************************************************************/

'Callback Funktion fr MakroLoop
'muss in unbedingt in einem Modul *.bas stehen damit AddressOf fr MakLoop funktioniert
'und mit eigenem Code ergnzen damit diese Funktion etwas sinnvolles tut
Public Function MakCB( _
       ByVal lngX As Long, _
       ByVal lngY As Long, _
       ByVal strFName As String, _
       ByVal strInfo As String, _
       ByVal lngInfoSize As Long, _
       ByRef varData As Variant) As Long
  
  'Hier eigenen Code einfgen
  '....
  
  'Rckgabewert mit Hilfe der Benuzterdefiniertendaten zuweisen
  '    =0  => break loop
  '   <>0  => continue loop
  MakCB = 1  'continue loop
End Function

'****************************C-CODE************************************/
'if 0      // documentation
'**********************************************************************/
'
'simple example using complete DC, no zooming
'
'void DrawPrt(
'        HWND hwnd,
'        HDC  hdc,
'        char *fname,
'        char *szIni )
'{
'    static HMODULE mhPrtDraw = NULL;
'
'    tfpDrawPrt fpDrawPrt = NULL;
'    tfpSetIni  fpSetIni  = NULL;
'
'    if ( !hwnd ) // at program exit
'    {
'        if ( mhPrtDraw )
'        {
'            FreeLibrary(mhPrtDraw);
'            mhPrtDraw = NULL;
'        }
'        return;
'    }
'    if ( !mhPrtDraw )
'        mhPrtDraw = LoadLibrary("prtdraw.dll"); // path ??
'    Else
'        szIni = NULL; // only first time
'    if ( mhPrtDraw )
'    {
'        fpDrawPrt = (tfpDrawPrt)GetProcAddress(mhPrtDraw,FN_DRAWPRT);
'        fpSetIni  = (tfpSetIni) GetProcAddress(mhPrtDraw,FN_SETINI );
'    }
'    if ( szIni && fpSetIni )
'        fpSetIni(szIni);
'    if ( fpDrawPrt )
'    {
'        RECT rect;
'        GetWindowRect(hwnd,&rect);
'        GetClientRect(hwnd,&rect);
'        DPtoLP(hdc,(LPPOINT)&rect,2);
'        fpDrawPrt(fname,hdc,&rect,NULL,NULL,15);
'    }
'}
'
'**********************************************************************/
'endif  // 0 (documentation)
'**********************************************************************/
